;       
;  - PIC16F84 (4.096 M),  - 107,  - DS18S20
; : , . , 
; :  MODE (  )
;  SET ( )
;  -   ,  +-1 
 

 	__CONFIG   _CP_OFF & _WDT_ON & _PWRTE_ON & _XT_OSC
#include p16f84.inc
#define lcd_rs		PORTB,4		; / (LCD 1)
#define	lcd_e		PORTB,5		;  (LCD 3)
#define	THERMO  	PORTA,0		; 
#define POWER		PORTA,4		; 
#define LIGHT_PORT	PORTA,3		; 
#define HEAT_PORT	PORTA,1		; 
#define LOAD_PORT	PORTA,2		; .

#define	CARRY		STATUS,C
#define	ZERO 		STATUS,Z
#define KEY_SET		flags,7		;  SET
#define KEY_MODE	flags,6		;  MODE
#define DS_ERR		flags,5		; 
#define CORR_BIT	flags,3		;0-  , 1- 
#define LOAD		flags,2		;. 
#define LIGHT		flags,1		; 
#define HEATER		flags,0		; 


INIT_OPTION	EQU	b'00000100'	;   , =32
INIT_INTCON	EQU	b'10100000'	;    


	cblock 0x0c
		d0,d1,d2,d3,d4,d5,d6,d7,d8,d9 	; 
		w_temp		;  W
		status_temp	;---- STATUS
		count		; 
		count2		
		hours		;   (HEX)
		minutes		
		seconds
		sec125
		screen		;   
				;0  : -     	 	/25 12-00/
				;1  :       /LIGHt  On //LIGHt OFF/
				;2  :     		/On   12-00/	
				;3  :    		/OFF  22-00/
				;4  :    /LOAd   On //LOAd  OFF/
				;5  :     		/On   12-00/	
				;6  :   		/OFF  22-00/
				;7  : 				/tEMP  24/
				;8  :   			/Hour 12-00/
				;9  :   			/Min  12-00/
				;10 : --		/ 12-00-00 /
				;11 :  	   		/Corr-00SEC/
				
		lig_on_hr	;  
		lig_on_min	;  
		lig_off_hr 	;  
		lig_off_min 	;  
		load_on_hr	;  
		load_on_min	;  
		load_off_hr 	;  
		load_off_min 	;  
		thermostat 	; 
		ret_count	;  
		hexdata		;HEX   
		decdata 	;DEC   
		dstemp		;  
		sendbyte	; 
		reseivebyte	; 
		newpress	; 
		oldpress	;,    
		flags		; 
		temp		; 
		time_corr	;  
		set_count	;  SET
	endc

; MACROS
ds_comm		macro		;   
		bcf PORTA,0
		bsf STATUS,RP0
		bcf TRISA^80h,0
		bcf STATUS,RP0
		endm

ds_data		macro		;   
		bsf STATUS,RP0
		bsf TRISA^80h,0
		bcf STATUS,RP0
		endm



	org 0x000
	goto begin
;   (125 ).
timeint		org 0x004			
		movwf w_temp		; STATUS, W
		movf STATUS,0
		movwf status_temp
		
; 
		movf newpress,0
		movwf oldpress
		movf PORTB,0
		andlw b'11000000'
		movwf newpress
		subwf oldpress,0
		btfsc  ZERO
		goto no_press
setpress	btfsc newpress,7
		goto press_mode
		bsf KEY_SET
		bcf KEY_MODE
		incf set_count
		goto end_key
press_mode	clrf set_count
		btfsc newpress,6
		goto no_press
		bcf KEY_SET
		bsf KEY_MODE
		goto end_key
no_press	bcf KEY_SET
		bcf KEY_MODE
end_key
		btfsc PORTB,7
		goto work_timer
		incf set_count
		movf set_count,0
		sublw .30
		btfss ZERO
		goto work_timer
		bsf KEY_SET
		clrf set_count
		
;
work_timer	movf sec125	;    
		btfss ZERO
		goto end_timers
		movf seconds
		btfss ZERO
		goto end_timers

; 	
		movf lig_on_hr,0
		subwf hours,0
		btfss ZERO
		goto no_light_on
		movf lig_on_min,0
		subwf minutes,0
		btfss ZERO
		goto no_light_on
		bsf LIGHT
no_light_on	movf lig_off_hr,0
		subwf hours,0
		btfss ZERO
		goto no_light_off
		movf lig_off_min,0
		subwf minutes,0
		btfss ZERO
		goto no_light_off
		bcf LIGHT
no_light_off	
; 
		movf load_on_hr,0
		subwf hours,0
		btfss ZERO
		goto no_load_on
		movf load_on_min,0
		subwf minutes,0
		btfss ZERO
		goto no_load_on
		bsf LOAD
no_load_on	movf load_off_hr,0
		subwf hours,0
		btfss ZERO
		goto no_load_off
		movf load_off_min,0
		subwf minutes,0
		btfss ZERO
		goto no_load_off
		bcf LOAD
no_load_off	
end_timers		
		
time_inc	incf sec125
		movf status_temp,0	; STATUS, W
		movwf STATUS	
		swapf w_temp,1
		swapf w_temp,0
		bcf INTCON,2
		clrwdt	
		
	retfie		; 

seg7		;   7-
		addwf PCL
		dt 0EEh, 060h, 02Fh, 06Dh, 0E1h; 0,1,2,3,4
		dt 0CDh, 0CFh, 068h, 0EFh, 0EDh; 5,6,7,8,9


;  
lcd_dw		;  	
		movwf temp
		movf temp,0	
		andlw 0x0F
		movwf PORTB
		bsf lcd_rs	
		bsf lcd_e
		bcf lcd_e
		swapf temp,0	
		andlw 0x0F
		movwf PORTB
		bsf lcd_rs	
		bsf lcd_e	
		bcf lcd_e
		return

lcd_cw		;  	
		movwf temp
		movf temp,0	
		andlw 0x0F
		movwf PORTB
		bcf lcd_rs
		bsf lcd_e
		bcf lcd_e
		swapf temp,0	
		andlw 0x0F
		movwf PORTB
		bcf lcd_rs
		bsf lcd_e	
		bcf lcd_e
		return



begin					; PIC
		bsf STATUS,RP0
		movlw b'00010000'
		movwf TRISA^80h
		movlw b'11000000'
		movwf TRISB^80h
		movlw INIT_OPTION
		movwf OPTION_REG^80h
		bcf STATUS,RP0
		movlw INIT_INTCON
		movwf INTCON
		clrf STATUS
		
					; 
		movlw 0x0F
		call lcd_cw
		movlw 1
		call lcd_dw

					;    WDT?
		btfss STATUS,4
		goto main_loop		;   

		; 
		movlw .12
		movwf hours
		movwf lig_on_hr
		movwf load_off_hr
		movlw .22
		movwf lig_off_hr
		movwf load_on_hr
		movlw .25
		movwf thermostat
		clrf minutes
		clrf seconds
		clrf sec125
		clrf flags
		clrf newpress
		clrf oldpress
		clrf screen
		clrf time_corr
		clrf lig_on_min
		clrf load_off_min
		clrf lig_off_min
		clrf load_on_min
		
; 
main_loop	
; 	
		movf sec125,0
		sublw .125
		btfss ZERO
		goto end_time
		incf seconds
		clrf sec125
		call thermometer	;  -  
		incf ret_count		;    
		movf seconds,0
		sublw .60
		btfss ZERO
		goto end_time
		incf minutes
		clrf seconds
		movf minutes,0
		sublw .60
		btfss ZERO
		goto end_time
		incf hours
		clrf minutes
		movf hours,0
		sublw .24
		btfss ZERO
		goto end_time
		clrf hours
		call corr		; 
		movf hours,0
		sublw .12
		btfss ZERO
		goto end_time
		bcf CORR_BIT		; 12  -   
		
end_time
		movf ret_count,0	;   60 ?
		sublw .60
		btfss ZERO
		goto end_ret_menu	
		clrf screen		;   
end_ret_menu
		

;   

; SET
		btfss KEY_SET
		goto keymode
		clrf ret_count
		
set1		movf screen,0		; 1    /LIGHt  On //LIGHt OFF/
		sublw .1
		btfss ZERO
		goto set2
		btfss LIGHT
		goto light_on
		bcf LIGHT
		goto off_key	
light_on	bsf LIGHT	
		goto off_key

set2		movf screen,0		; 2    /On   12-00/
		sublw .2
		btfss ZERO
		goto set3
		movlw .15
		addwf lig_on_min
		movf lig_on_min,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf lig_on_min
		incf lig_on_hr
		movf lig_on_hr,0
		sublw .24
		btfsc ZERO
		clrf lig_on_hr
		goto off_key		
		
set3		movf screen,0		; 3    /OFF  22-00/
		sublw .3
		btfss ZERO
		goto set4
		movlw .15
		addwf lig_off_min
		movf lig_off_min,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf lig_off_min
		incf lig_off_hr
		movf lig_off_hr,0
		sublw .24
		btfsc ZERO
		clrf lig_off_hr
		goto off_key		
		
set4		movf screen,0		; 4    /LOAd   On //LOAd  OFF/
		sublw .4
		btfss ZERO
		goto set5
		btfss LOAD
		goto on_load
		bcf LOAD
		goto off_key	
on_load		bsf LOAD	
		goto off_key

set5		movf screen,0		; 5    /On   12-00/
		sublw .5
		btfss ZERO
		goto set6
		movlw .15
		addwf load_on_min
		movf load_on_min,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf load_on_min
		incf load_on_hr
		movf load_on_hr,0
		sublw .24
		btfsc ZERO
		clrf load_on_hr
		goto off_key		
	
set6		movf screen,0		; 6    /OFF  22-00/
		sublw .6
		btfss ZERO
		goto set7
		movlw .15
		addwf load_off_min
		movf load_off_min,0
		sublw .60
		btfss ZERO
		goto off_key
		clrf load_off_min
		incf load_off_hr
		movf load_off_hr,0
		sublw .24
		btfsc ZERO
		clrf load_off_hr
		goto off_key		
	
set7		movf screen,0		; 7 	/tEMP  24/
		sublw .7
		btfss ZERO
		goto set8
		incf thermostat
		movf thermostat,0
		sublw .40
		btfsc ZERO
		call set20deg
		goto off_key

set8		movf screen,0		; 8   /Hour 12-00/
		sublw .8
		btfss ZERO
		goto set9
		incf hours
		movf hours,0
		sublw .24
		btfsc ZERO
		clrf hours
		goto off_key
		
set9		movf screen,0		; 9   /Min  12-00/
		sublw .9
		btfss ZERO
		goto set10
		incf minutes
		movf minutes,0
		sublw .60
		btfsc ZERO
		clrf minutes
		goto off_key	

set10		movf screen,0		; 10 -- / 12-00-00 /
		sublw .10
		btfss ZERO
		goto set11
		clrf seconds
		clrf minutes
		clrf sec125
		goto off_key	

set11		movf screen,0		; 11   /Corr 00SEC/
		sublw .11
		btfss ZERO
		goto off_key
		incf time_corr
		movf time_corr,0
		sublw .21
		btfsc ZERO
		call minus20
		
		goto off_key		
	
	
; MODE
keymode		btfss KEY_MODE
		goto off_key
		clrf ret_count
		incf screen
		movf screen,0
		sublw .12
		btfsc ZERO
		clrf screen
off_key		bcf KEY_SET
		bcf KEY_MODE

; 
power_ctrl	btfss POWER	;   
		goto no_power	;  
		btfss HEATER
		goto no_heat
		bsf HEAT_PORT
		goto light_test
no_heat		bcf HEAT_PORT
light_test	btfss LIGHT
		goto no_light
		bsf LIGHT_PORT
		goto load_test
no_light	bcf LIGHT_PORT
load_test	btfss LOAD
		goto no_load
		bsf LOAD_PORT
		goto end_power
no_load		bcf LOAD_PORT
		goto end_power
no_power	bcf LIGHT_PORT
		bcf HEAT_PORT
		bcf LOAD_PORT	 
end_power


; 
		movf screen,0		; 0 - /25 12-00/
		btfss ZERO
		goto scr1
		btfsc DS_ERR
		goto therm_ok
		movlw b'00000001'
		movwf d0
		movwf d1
		goto next_scr
therm_ok	movf dstemp,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d0
		movf hexdata,0
		call seg7		;  7- 
		movwf d1
next_scr	movlw b'10101001'
		movwf d2
		movlw b'00000111'
		movwf d3
		clrf d4
		movf hours,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movf minutes,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		btfss sec125,6
		goto space_char
		movlw b'00000001'
		goto poke
space_char	movlw b'00000000'
poke		movwf d7
		goto  end_screen

scr1		movf screen,0		; 1     /LIGHt  On //LIGHt  OFF/				
		sublw .1
		btfss ZERO
		goto scr2
		movlw b'10000110'
		movwf d0
		movlw 0x60
		movwf d1
		movlw b'11001110'
		movwf d2
		movlw b'11100011'
		movwf d3
		movlw b'10000111'
		movwf d4
		clrf d5
		clrf d6
		btfsc LIGHT
		goto lig_show_on
		movlw 0xEE
		movwf d7
		movlw b'10001011'
		movwf d8
		movwf d9
		goto end_screen
lig_show_on	movlw 0xEE
		movwf d7
		movlw b'01000011'
		movwf d8
		clrf d9
		goto end_screen
			
scr2		movf screen,0		; 2     /On   12-00/
		sublw .2
		btfss ZERO
		goto scr3
		movlw 0xEE
		movwf d0
		movlw b'01000011'
		movwf d1
		clrf d2
		clrf d3
		clrf d4
		movlw b'00000001'
		movwf d7
		movf lig_on_hr,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movf lig_on_min,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		goto  end_screen

scr3		movf screen,0		; 3    /OFF  22-00/
		sublw .3
		btfss ZERO
		goto scr4
		movlw 0xEE
		movwf d0
		movlw b'10001011'
		movwf d1
		movwf d2
		movlw 0
		movwf d3
		movwf d4
		movlw b'00000001'
		movwf d7
		movf lig_off_hr,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movf lig_off_min,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		goto  end_screen

scr4		movf screen,0		; 4    /LOAd   On //LOAd   OFF/				
		sublw .4
		btfss ZERO
		goto scr5
		movlw b'10000110'
		movwf d0
		movlw 0xEE
		movwf d1
		movlw b'11101011'
		movwf d2
		movlw b'01100111'
		movwf d3
		clrf d4
		clrf d5
		clrf d6
		btfsc LOAD
		goto show_load_on_hr
		movlw 0xEE
		movwf d7
		movlw b'10001011'
		movwf d8
		movwf d9
		goto end_screen
show_load_on_hr	movlw 0xEE
		movwf d7
		movlw b'01000011'
		movwf d8
		clrf d9
		goto end_screen	
	
scr5		movf screen,0		; 5     /On   12-00/
		sublw .5
		btfss ZERO
		goto scr6
		movlw 0xEE
		movwf d0
		movlw b'01000011'
		movwf d1
		movlw 0
		movwf d2
		movwf d3
		movwf d4
		movlw b'00000001'
		movwf d7
		movf load_on_hr,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movf load_on_min,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		goto  end_screen

scr6		movf screen,0		; 6    /OFF  22-00/
		sublw .6
		btfss ZERO
		goto scr7
		movlw 0xEE
		movwf d0
		movlw b'10001011'
		movwf d1
		movwf d2
		movlw 0
		movwf d3
		movwf d4
		movlw b'00000001'
		movwf d7
		movf load_off_hr,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movf load_off_min,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		goto  end_screen

scr7		movf screen,0		; 7 	/tEMP  24/
		sublw .7
		btfss ZERO
		goto scr8
		movlw b'10000111'
		movwf d0
		movlw b'10001111'
		movwf d1
		movlw b'10101010'
		movwf d2
		movlw b'11101000'
		movwf d3
		movlw b'10101011'
		movwf d4
		clrf d5
		movf thermostat,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d6
		movf hexdata,0
		call seg7		;  7- 
		movwf d7
		movlw b'10101001'
		movwf d8
		movlw b'00000111'
		movwf d9
		goto  end_screen
		
scr8		movf screen,0		; 8   /Hour 12-00/
		sublw .8
		btfss ZERO
		goto scr9
		movlw b'11100011'
		movwf d0
		movlw b'01000111'
		movwf d1
		movlw b'01000110'
		movwf d2
		movlw b'00000011'
		movwf d3
		clrf d4
		movf hours,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movlw b'00000001'
		movwf d7
		movf minutes,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		goto  end_screen
		
		

scr9		movf screen,0		; 9   /Min  12-00/
		sublw .9
		btfss ZERO
		goto scr10
		movlw b'10101010'
		movwf d0
		movlw b'11101000'
		movwf d1
		movlw b'01000000'
		movwf d2
		movlw b'01000011'
		movwf d3
		clrf d4
		movf hours,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		movlw b'00000001'
		movwf d7
		movf minutes,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d8
		movf hexdata,0
		call seg7		;  7- 
		movwf d9
		goto  end_screen
		
scr10		movf screen,0		; 10 -- / 12-00-00 /
		sublw .10
		btfss ZERO
		goto scr11
		movlw b'00000001'
		movwf d3
		movwf d6
		clrf d0
		clrf d9
		movf hours,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d1
		movf hexdata,0
		call seg7		;  7- 
		movwf d2
		movf minutes,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d4
		movf hexdata,0
		call seg7		;  7- 
		movwf d5
		movf seconds,0
		call convert
		movf decdata,0
		call seg7		;  7- 
		movwf d7
		movf hexdata,0
		call seg7		;  7- 
		movwf d8
		goto  end_screen

scr11		movf screen,0		; 11  /Corr 00SEC/
		sublw .11
		btfss ZERO
		goto end_screen
		movlw b'10001110'
		movwf d0
		movlw b'01000111'
		movwf d1
		movlw b'00000011'
		movwf d2
		movwf d3
		movlw 0xCD
		movwf d7
		movlw b'10001111'
		movwf d8
		movlw b'10001110'
		movwf d9
		btfsc time_corr,7
		goto neg_scr
pos_scr		clrf d4
		movf time_corr,0
		goto corr_conv
neg_scr		movlw b'00000001'
		movwf d4
		comf time_corr,0
		movwf temp
		incf temp,0
corr_conv	call convert		
		movf decdata,0
		call seg7		;  7- 
		movwf d5
		movf hexdata,0
		call seg7		;  7- 
		movwf d6
		 
		
		
		
end_screen
;  
		movlw 0
		call lcd_cw
		movf d0,0
		call lcd_dw
		movf d1,0
		call lcd_dw
		movf d2,0
		call lcd_dw
		movf d3,0
		call lcd_dw
		movf d4,0
		call lcd_dw
		movf d5,0
		call lcd_dw
		movf d6,0
		call lcd_dw
		movf d7,0
		call lcd_dw
		movf d8,0
		call lcd_dw
		movf d9,0
		call lcd_dw

		goto main_loop

thermometer	call init_therm
		btfsc DS_ERR
		goto ds_enable
		movlw 0xFF	
		movwf dstemp
		goto end_THERMO
		
ds_enable	movlw 0xCC	; 
		call send
		movlw 0xBE
		call send
		call reseive
		movwf dstemp
		call reseive
		movwf temp
		call init_therm ; 
		movlw 0xCC	; 
		call send
		movlw 0x44
		call send
		rrf dstemp
		bcf dstemp,7
; 
		movf thermostat,0
		subwf dstemp,0
		btfsc CARRY
		goto off_heat
		bsf HEATER
off_heat	movf dstemp,0
		subwf thermostat,0
		btfsc CARRY
		goto end_THERMO
		bcf HEATER
end_THERMO	btfsc DS_ERR
		goto heat_ok
		bcf HEATER		
heat_ok		return	

init_therm	; 
		bsf DS_ERR	;,   
		movlw .20	;  
		movwf count2
		ds_comm
		bcf THERMO	;
	  	movlw .170	; 500 
		movwf count
delinittherm	decfsz count
		goto delinittherm
		bsf THERMO
		ds_data
init_ansv	btfss THERMO	; 
		goto end_ansv
		decfsz count2
		goto init_ansv
		bcf DS_ERR	;   >  
		return
end_ansv	btfss THERMO	;  
		goto end_ansv
		return

send		; 
		movwf sendbyte	;  
		movlw .8
		movwf count2
sendloop	ds_comm
		rrf sendbyte
		btfsc CARRY
		bsf THERMO
		call wait50
		ds_data
		decfsz count2
		goto sendloop
		return
		
reseive		;  		
		movlw .8
		movwf count2
reseiveloop	ds_comm
		ds_data
		bcf CARRY
		btfsc THERMO
		bsf CARRY
		rrf reseivebyte 
		call wait50	
		decfsz count2
		goto reseiveloop
		movf reseivebyte,0
		return



wait50		movlw .12	; 50
		movwf count
loop50		nop
		decfsz count
		goto loop50
		return

convert		;  2  ASCII 	
		movwf hexdata
	        movlw .8 
                movwf count 
                clrf decdata 
                goto start 

adjdec          movlw 0x33 
                addwf decdata 

                movlw 0x03 
                btfss decdata,3 
                subwf decdata 

                movlw 0x30 
                btfss decdata,7 
                subwf decdata 

start           rlf hexdata 
                rlf decdata 
                decfsz count 
                goto adjdec 
		
		movf decdata,0
		andlw 0x0f		
		movwf hexdata	; 
				
		swapf decdata,0
		andlw 0x0f
		movwf decdata	; 
		return


set20deg	; 20 
		movlw .20
		movwf thermostat
		return
minus20		;  -20
		movlw .236
		movwf time_corr
		return


corr		; 
		btfsc CORR_BIT		;   
		goto end_corr
		bsf CORR_BIT
		btfsc time_corr,7	;  
		goto neg_corr
pos_corr	movf time_corr,0
		movwf seconds
		goto end_corr
neg_corr	comf time_corr,0	; .    	
		sublw .59
		movwf seconds
		movlw .59
		movwf minutes
		movlw .23
		movwf hours
end_corr	return
		
	end
